import 'package:cruiser/src/models/cruiser_args.dart';
import 'package:cruiser/src/enums/transition_type.dart';
import 'package:flutter/widgets.dart';

class ArgumentsWrapper 
{
    final Widget exitPage;
    final CruiserArgs cruiserArgs;
    final TransitionType transition;

    ArgumentsWrapper
    ({
        this.cruiserArgs,
        this.transition,
        this.exitPage
    });

    ArgumentsWrapper copyWith
    ({
        CruiserArgs cruiserArgs,
        TransitionType transition,
        Widget exitPage
    }) 
    {
        return ArgumentsWrapper(
            cruiserArgs: cruiserArgs ?? this.cruiserArgs,
            transition: transition ?? this.transition,
            exitPage: exitPage ?? this.exitPage
        );
    }

    @override
    String toString() 
    {
        return 
            'ArgumentsWrapper{cruiserArgs: $cruiserArgs, '
            'transition: $transition, ';
    }
}
