import 'package:cruiser/src/enums/transition_type.dart';
import 'package:flutter/material.dart';

/// Options to configure a Cruiser instance.
class CruiserOptions 
{
    final bool handleNameNotFoundUI;

    final bool isLoggingEnabled;

    final TransitionType defaultTransition;

    final GlobalKey<NavigatorState> navigatorKey;

    const CruiserOptions
    ({
        this.handleNameNotFoundUI = false,
        this.isLoggingEnabled = false,
        this.defaultTransition = TransitionType.cube,
        this.navigatorKey,
    })  : assert(handleNameNotFoundUI != null),
          assert(isLoggingEnabled != null);
}
