
import 'package:cruiser/src/models/cruiser_transition.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

class BackgroundToForegroundTransition extends CruiserTransition
{
    final Curve curve;
    final Color backgroundColor;
    final double scale;

    BackgroundToForegroundTransition({
        this.curve = Curves.easeOutSine,
        this.backgroundColor = Colors.black,
        this.scale = 0.5,
    });

    @override
    Widget build(BuildContext context, Animation<double> animation, Widget exitPage, Widget enterPage) 
    {
        animation = CurvedAnimation(parent: animation, curve: curve);
        final double width = MediaQuery.of(context).size.width;
        return Stack(
        children: [
            Container(color: backgroundColor),
            Transform(
            transform: Matrix4.identity()..translate(-width * animation.value),
            child: exitPage,
            ),
            Transform(
            alignment: Alignment.center,
            transform: Matrix4.identity()
                ..scale(1.0 - (1.0 - scale) * (1.0 - animation.value))
                ..leftTranslate(width * (1.0 - animation.value)),
            child: enterPage,
            ),
        ],
        );
    }
}
