
import 'package:cruiser/src/models/cruiser_transition.dart';
import 'package:flutter/widgets.dart';

class StackTransition extends CruiserTransition
{
    final Curve curve;

    StackTransition({
        this.curve = Curves.easeOutSine,
    });

    @override
    Widget build(BuildContext context, Animation<double> animation, Widget exitPage, Widget enterPage)
    {
        animation = CurvedAnimation(parent: animation, curve: curve);
        double width = MediaQuery.of(context).size.width;
        return Transform(
        transform: Matrix4.identity()..translate(width * (1.0 - animation.value)),
        child: enterPage,
        );
    }
}